#include "DOshooter.h"


OBJ ammo[MAX_AMMO];


/*
  ammo procedure.
*/

void AmmoProc(void) {

	int i;  //for for loop.
	const float ammospeed = 1.5;  //ammo speed. pixels/frame.

	const int choose_n = 5;   //the number of ammounts of ammos to be selected.
	OBJ* pammo;               //temp pointer to chosen ammo.


	/* choose ammo to be visible */
	srand((unsigned)time(NULL));  //reset randam number generator.

	for (i = 0; i < choose_n; i++) {  //choose 5 ammos.

		pammo = &ammo[rand() % MAX_AMMO];  //chosen ammo.

		if (pammo->visible_f == FALSE) {  //if chosen ammo was invisible,

			pammo->cords.x = rand() % 1280;  //set x-cord.
			pammo->visible_f = TRUE;         //set visible flag.
		}
	}

	/* process visible ammos */
	for (i = 0; i < MAX_AMMO; i++) {
		if (ammo[i].visible_f == TRUE) {

			ammo[i].cords.y += ammospeed;  //move ammo.

			if (ammo[i].cords.y > 720) {  //if found an ammo reached the bottom,

				ammo[i].cords = { 0, 0, 0 };  //reset cords.
				ammo[i].visible_f = FALSE;  //clear visible flag.
			}
			if (collision(&ammo[i])) {  //if collision detected,

				gameover();
			}
		}

	/* draw on backbuffer */
		if (ammo[i].visible_f == TRUE) {
			if (SUCCEEDED(IDirect3DDevice9_BeginScene(pDevice))) {

				ammo[i].pSprite->Begin(D3DXSPRITE_ALPHABLEND);
				ammo[i].pSprite->Draw(   //draw sprite.
					ammo[i].pTexture,           //texture.
					NULL,		  	    //
					NULL,			    //
					&ammo[i].cords,        //
					0xFFFFFFFF          //do not chage looks of the picture.
				);

				ammo[i].pSprite->End();
				IDirect3DDevice9_EndScene(pDevice);
			}	
		}
	}
}


/*
  function to detect collision detection. 
  returns 1 if collision detected.
*/

int collision(OBJ *obj) {

	float xleft = obj->cords.x + obj->rect.left;     //left top vertex of the objects hitbox.
	float ytop = obj->cords.y + obj->rect.top;
	float xright = obj->cords.x + obj->rect.right;   //right bottom vertex of the objects hitbox.
	float ybottom = obj->cords.y + obj->rect.bottom;

	float left = ship.cords.x + ship.rect.left;     //left top vertex of the ships hitbox.
	float top = ship.cords.y + ship.rect.top;
	float right = ship.cords.x + ship.rect.right;   //right bottom vertex of the ships hitbox.
	float bottom = ship.cords.y + ship.rect.bottom;

	if ((xleft > left) && (xleft < right) && (ytop > top) && (ytop < bottom))	return 1;          //left top.
	if ((xright > left) && (xright < right) && (ytop > top) && (ytop < bottom))	return 1;          //right top.
	if ((xright > left) && (xright < right) && (ytop > top) && (ytop < bottom))	return 1;          //right top.
	if ((xright > left) && (xright < right) && (ybottom > top) && (ybottom < bottom))	return 1;  //right bottom.

	return 0;
}


/*
  function called when gameover occurred.
*/

void gameover(void) {

	Sleep(500);
	AmmoInit();
}


/*
  function to create sprite from image.
*/

void CreateSprite(OBJ* obj) {

	/* create texture object */
	D3DXCreateTextureFromFileEx(
		pDevice,
		obj -> img,
		obj -> rect.right - obj -> rect.left,      //image width.
		obj -> rect.bottom - obj -> rect.top,      //image height.
		D3DX_DEFAULT,      //mipmap level.
		0,                 //???
		D3DFMT_UNKNOWN,    //file format
		D3DPOOL_DEFAULT,   //???
		D3DX_FILTER_NONE,  //no filters.
		D3DX_DEFAULT,      //no mipfilters.
		0xFF000000,        //make specific color to be invisible, ARGB. in this case, black will be invisible.
		NULL,
		NULL,
		&obj -> pTexture
	);

	D3DXCreateSprite(pDevice, &obj -> pSprite);  //create sprite.

}


/*
  ammo initializer.
*/

void AmmoInit(void) {

	int i;  //for for loop.
	RECT ammorect = { 0, 0, 10, 10 };   //10x10 ammo size.

	for (i = 0; i < MAX_AMMO; i++) {  //initialize ammo.

		ammo[i] = {
			{ 0, 0, 0 },
			"img/ammo.png",
			FALSE,          //invisible.
			ammorect,
			NULL,NULL
		};

		CreateSprite(&ammo[i]);
	}
}


/*
  function to clear screen with black.
*/

void ClearS(void) {

	IDirect3DDevice9Ex_Clear(    //Clear screen with black. class...
		pDevice,
		0,                       //numbers no rectangles in the array at pRects(the next argument).
		NULL,                    //clear the hole window.
		D3DCLEAR_TARGET,
		D3DCOLOR_XRGB(0, 0, 0),  //use black.
		1.0f,
		0
	);
}