#pragma once

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <windows.h>
#include <windowsx.h>
#include <d3d9.h>
#include <d3dx9.h>
#include <d3dx9core.h>
#include <d3dx9effect.h>
#include <dinput.h>

extern LPDIRECT3D9 pD3d;             //pointer to Direct3d object.
extern LPDIRECT3DDEVICE9 pDevice;    //pointer to Direct3d device object.

extern LPDIRECTINPUT8 pDinput;            //pointer of DirectInput object.
extern LPDIRECTINPUTDEVICE8 pKeyDevice;   //pointer of DirectInput device object.
extern LPD3DXFONT m_pFont;                //something about fonts.

extern HWND hWnd;      //handle.
extern WNDCLASSEX wc;  //windows class.


typedef struct {
	D3DXVECTOR3 cords;                //coordinates.
	char*  img;                       //name of image
	char visible_f;                   //set when object is visible.
	RECT rect;                        //hitbox.
	LPDIRECT3DTEXTURE9 pTexture;      //pointer to texture object.
	LPD3DXSPRITE pSprite;             //pointer to sprite object.
} OBJ;    //structure to contain the object's detail.


#define MAX_AMMO  50  //number of max ammo.

extern OBJ ammo[MAX_AMMO];
extern OBJ ship;


extern void CreateSprite(OBJ* obj);
extern void AmmoInit(void);
extern void ClearS(void);
extern void AmmoProc(void);
extern int collision(OBJ *obj);
extern void gameover(void);